'use strict'
Object.defineProperty(exports, '__esModule', { value: !0 }),
  require('reflect-metadata')
var e = require('tslib'),
  r = require('lodash.get'),
  a = require('lodash.set')
function t(e) {
  return e && 'object' == typeof e && 'default' in e ? e : { default: e }
}
var n,
  i = t(r),
  o = t(a)
function s(e) {
  var r = e.propName,
    a = e.propPath,
    t = e.propValue,
    n = e.json,
    i = e.serializableClass
  if (void 0 === t)
    throw new d({ json: n, propName: r, serializableClass: i, propPath: a })
}
function l(e) {
  return !!e && void 0 !== Reflect.getMetadata(n.TsJacksonSerializable, e)
}
!(function (e) {
  ;(e.TsJacksonJsonProperty = 'ts-jackson:jsonproperty'),
    (e.TsJacksonSerializable = 'ts-jackson:serializable'),
    (e.DesignType = 'design:type'),
    (e.DesignParamTypes = 'design:paramtypes')
})(n || (n = {}))
var u = (function (r) {
  function a(e) {
    var a = r.call(this) || this
    return (
      (a.name = 'SerializableError'),
      (a.message =
        e.name + ' class should annotated with @' + h.name + ' decorator'),
      a
    )
  }
  return e.__extends(a, r), a
})(Error)
function p(e) {
  if (!l(e)) throw new u(e)
}
function c(e) {
  var r = e.propName,
    a = e.propValue,
    t = e.validate,
    n = e.serializableClass
  if (!t(a))
    throw new y({
      propName: r,
      propValue: a,
      validate: t,
      serializableClass: n,
    })
}
var f,
  d = (function (r) {
    function a(e) {
      var a = e.propName,
        t = e.propPath,
        n = e.json,
        i =
          "Property '" +
          a +
          "' is required in " +
          e.serializableClass.name +
          '\n     but missing in ' +
          JSON.stringify(n) +
          ' by path ' +
          t +
          '.'
      return r.call(this, i) || this
    }
    return e.__extends(a, r), a
  })(Error),
  y = (function (r) {
    function a(e) {
      var a = e.propName,
        t = e.propValue,
        n = e.validate,
        i =
          "Property '" +
          a +
          "' = " +
          t +
          ' in ' +
          e.serializableClass.name +
          '\n    failed to path ' +
          n +
          ' check'
      return r.call(this, i) || this
    }
    return e.__extends(a, r), a
  })(Error)
function h() {
  return function (e) {
    Reflect.defineMetadata(n.TsJacksonSerializable, { className: e.name }, e)
  }
}
function v(r, a) {
  for (var t = [], l = 2; l < arguments.length; l++) t[l - 2] = arguments[l]
  p(a)
  for (
    var u = Reflect.getMetadata(n.TsJacksonJsonProperty, a),
      f = new (a.bind.apply(a, e.__spreadArray([void 0], t)))(),
      d = 'string' == typeof r ? JSON.parse(r) : r,
      y = [],
      h = 0,
      v = Object.entries(u);
    h < v.length;
    h++
  ) {
    var b = v[h],
      z = b[0],
      g = b[1],
      S = g.paths
        ? g.paths.map(function (e) {
            return i.default(d, e)
          })
        : i.default(d, g.path)
    g.required &&
      s({
        json: d,
        propName: z,
        propValue: S,
        serializableClass: a,
        propPath: g.path,
      })
    var N = g.deserialize ? g.deserialize(S) : m(S, g.type, g.elementType)
    g.validate &&
      c({
        propName: z,
        propValue: N,
        validate: g.validate,
        serializableClass: a,
      }),
      void 0 !== N && o.default(f, z, N),
      g.afterDeserialize &&
        y.push({
          propName: z,
          deserializedValue: N,
          afterDeserialize: g.afterDeserialize,
        })
  }
  return (
    y.forEach(function (e) {
      var r = e.propName,
        a = e.deserializedValue,
        t = e.afterDeserialize
      o.default(f, r, t(f, a))
    }),
    f
  )
}
function m(e, r, a) {
  if (null == e || void 0 === r) return e
  if (Array.isArray(r))
    return r.map(function (r, a) {
      return m(e[a], r)
    })
  if ('function' == typeof r)
    switch (null == r ? void 0 : r.name) {
      case f.Date:
        return new Date(e)
      case f.Array:
        return e.map(function (e) {
          return l(a) ? v(e, a) : e
        })
      case f.Set:
        var t = e.map(function (e) {
          return l(a) ? v(e, a) : e
        })
        return new Set(t)
      case f.Boolean:
        return Boolean(e)
      case f.Number:
        return Number.parseInt(e)
      case f.String:
        return e.toString()
      default:
        return l(r) ? v(e, r) : e
    }
}
function b(e) {
  p(e.constructor)
  for (
    var r = Reflect.getMetadata(n.TsJacksonJsonProperty, e.constructor),
      a = {},
      t = function (r, t) {
        var n = void 0,
          i = void 0
        t.beforeSerialize
          ? (i = (n = t.beforeSerialize(e[r])).constructor)
          : ((n = e[r]), (i = t.type))
        var s = t.serialize ? t.serialize(n) : z(n, i)
        t.paths
          ? t.paths.forEach(function (e, r) {
              o.default(a, e, s[r])
            })
          : o.default(a, t.path, s)
      },
      i = 0,
      s = Object.entries(r);
    i < s.length;
    i++
  ) {
    var l = s[i]
    t(l[0], l[1])
  }
  return a
}
function z(e, r) {
  if (void 0 === e) return e
  if (Array.isArray(r))
    return r.map(function (r, a) {
      return z(e[a], r)
    })
  if ('function' == typeof r)
    switch (null == r ? void 0 : r.name) {
      case f.Set:
      case f.Array:
        return Array.from(e.values()).map(function (e) {
          return l(e.constructor) ? b(e) : e
        })
      default:
        return l(r) ? b(e) : e
    }
}
!(function (e) {
  ;(e.Array = 'Array'),
    (e.Set = 'Set'),
    (e.Boolean = 'Boolean'),
    (e.Date = 'Date'),
    (e.Number = 'Number'),
    (e.Object = 'Object'),
    (e.String = 'String')
})(f || (f = {}))
var g = (function () {
  function r() {}
  return (
    (r.prototype.stringify = function () {
      return JSON.stringify(this.serialize())
    }),
    (r.prototype.serialize = function () {
      return b(this)
    }),
    (r.deserialize = function (r) {
      for (var a = [], t = 1; t < arguments.length; t++) a[t - 1] = arguments[t]
      return v.apply(void 0, e.__spreadArray([r, this], a))
    }),
    (r = e.__decorate([h()], r))
  )
})()
;(exports.JsonProperty = function (r) {
  return (
    void 0 === r && (r = {}),
    function (a, t) {
      var i
      switch (!0) {
        case 'string' == typeof r:
          i = { path: r }
          break
        case Array.isArray(r):
          i = { paths: r }
          break
        default:
          i = r
      }
      var o = i.type || Reflect.getMetadata('design:type', a, t),
        s = Reflect.getMetadata(n.TsJacksonJsonProperty, a.constructor) || {}
      ;(s[t] = e.__assign({ type: o, name: t, path: t }, i)),
        Reflect.defineMetadata(n.TsJacksonJsonProperty, s, a.constructor)
    }
  )
}),
  (exports.Serializable = h),
  (exports.SerializableEntity = g),
  (exports.deserialize = v),
  (exports.serialize = b)
//# sourceMappingURL=index.cjs.js.map
