import 'reflect-metadata'
import {
  __extends as e,
  __spreadArray as r,
  __assign as a,
  __decorate as t,
} from 'tslib'
import n from 'lodash.get'
import i from 'lodash.set'
function o(e) {
  var r = e.propName,
    a = e.propPath,
    t = e.propValue,
    n = e.json,
    i = e.serializableClass
  if (void 0 === t)
    throw new d({ json: n, propName: r, serializableClass: i, propPath: a })
}
var s
function l(e) {
  return !!e && void 0 !== Reflect.getMetadata(s.TsJacksonSerializable, e)
}
!(function (e) {
  ;(e.TsJacksonJsonProperty = 'ts-jackson:jsonproperty'),
    (e.TsJacksonSerializable = 'ts-jackson:serializable'),
    (e.DesignType = 'design:type'),
    (e.DesignParamTypes = 'design:paramtypes')
})(s || (s = {}))
var u = (function (r) {
  function a(e) {
    var a = r.call(this) || this
    return (
      (a.name = 'SerializableError'),
      (a.message =
        e.name + ' class should annotated with @' + h.name + ' decorator'),
      a
    )
  }
  return e(a, r), a
})(Error)
function p(e) {
  if (!l(e)) throw new u(e)
}
function c(e) {
  var r = e.propName,
    a = e.propValue,
    t = e.validate,
    n = e.serializableClass
  if (!t(a))
    throw new m({
      propName: r,
      propValue: a,
      validate: t,
      serializableClass: n,
    })
}
var f,
  d = (function (r) {
    function a(e) {
      var a = e.propName,
        t = e.propPath,
        n = e.json,
        i =
          "Property '" +
          a +
          "' is required in " +
          e.serializableClass.name +
          '\n     but missing in ' +
          JSON.stringify(n) +
          ' by path ' +
          t +
          '.'
      return r.call(this, i) || this
    }
    return e(a, r), a
  })(Error),
  m = (function (r) {
    function a(e) {
      var a = e.propName,
        t = e.propValue,
        n = e.validate,
        i =
          "Property '" +
          a +
          "' = " +
          t +
          ' in ' +
          e.serializableClass.name +
          '\n    failed to path ' +
          n +
          ' check'
      return r.call(this, i) || this
    }
    return e(a, r), a
  })(Error)
function h() {
  return function (e) {
    Reflect.defineMetadata(s.TsJacksonSerializable, { className: e.name }, e)
  }
}
function v(e, a) {
  for (var t = [], l = 2; l < arguments.length; l++) t[l - 2] = arguments[l]
  p(a)
  for (
    var u = Reflect.getMetadata(s.TsJacksonJsonProperty, a),
      f = new (a.bind.apply(a, r([void 0], t)))(),
      d = 'string' == typeof e ? JSON.parse(e) : e,
      m = [],
      h = 0,
      v = Object.entries(u);
    h < v.length;
    h++
  ) {
    var b = v[h],
      z = b[0],
      g = b[1],
      N = g.paths
        ? g.paths.map(function (e) {
            return n(d, e)
          })
        : n(d, g.path)
    g.required &&
      o({
        json: d,
        propName: z,
        propValue: N,
        serializableClass: a,
        propPath: g.path,
      })
    var S = g.deserialize ? g.deserialize(N) : y(N, g.type, g.elementType)
    g.validate &&
      c({
        propName: z,
        propValue: S,
        validate: g.validate,
        serializableClass: a,
      }),
      void 0 !== S && i(f, z, S),
      g.afterDeserialize &&
        m.push({
          propName: z,
          deserializedValue: S,
          afterDeserialize: g.afterDeserialize,
        })
  }
  return (
    m.forEach(function (e) {
      var r = e.propName,
        a = e.deserializedValue,
        t = e.afterDeserialize
      i(f, r, t(f, a))
    }),
    f
  )
}
function y(e, r, a) {
  if (null == e || void 0 === r) return e
  if (Array.isArray(r))
    return r.map(function (r, a) {
      return y(e[a], r)
    })
  if ('function' == typeof r)
    switch (null == r ? void 0 : r.name) {
      case f.Date:
        return new Date(e)
      case f.Array:
        return e.map(function (e) {
          return l(a) ? v(e, a) : e
        })
      case f.Set:
        var t = e.map(function (e) {
          return l(a) ? v(e, a) : e
        })
        return new Set(t)
      case f.Boolean:
        return Boolean(e)
      case f.Number:
        return Number.parseInt(e)
      case f.String:
        return e.toString()
      default:
        return l(r) ? v(e, r) : e
    }
}
function b(e) {
  p(e.constructor)
  for (
    var r = Reflect.getMetadata(s.TsJacksonJsonProperty, e.constructor),
      a = {},
      t = function (r, t) {
        var n = void 0,
          o = void 0
        t.beforeSerialize
          ? (o = (n = t.beforeSerialize(e[r])).constructor)
          : ((n = e[r]), (o = t.type))
        var s = t.serialize ? t.serialize(n) : z(n, o)
        t.paths
          ? t.paths.forEach(function (e, r) {
              i(a, e, s[r])
            })
          : i(a, t.path, s)
      },
      n = 0,
      o = Object.entries(r);
    n < o.length;
    n++
  ) {
    var l = o[n]
    t(l[0], l[1])
  }
  return a
}
function z(e, r) {
  if (void 0 === e) return e
  if (Array.isArray(r))
    return r.map(function (r, a) {
      return z(e[a], r)
    })
  if ('function' == typeof r)
    switch (null == r ? void 0 : r.name) {
      case f.Set:
      case f.Array:
        return Array.from(e.values()).map(function (e) {
          return l(e.constructor) ? b(e) : e
        })
      default:
        return l(r) ? b(e) : e
    }
}
function g(e) {
  return (
    void 0 === e && (e = {}),
    function (r, t) {
      var n
      switch (!0) {
        case 'string' == typeof e:
          n = { path: e }
          break
        case Array.isArray(e):
          n = { paths: e }
          break
        default:
          n = e
      }
      var i = n.type || Reflect.getMetadata('design:type', r, t),
        o = Reflect.getMetadata(s.TsJacksonJsonProperty, r.constructor) || {}
      ;(o[t] = a({ type: i, name: t, path: t }, n)),
        Reflect.defineMetadata(s.TsJacksonJsonProperty, o, r.constructor)
    }
  )
}
!(function (e) {
  ;(e.Array = 'Array'),
    (e.Set = 'Set'),
    (e.Boolean = 'Boolean'),
    (e.Date = 'Date'),
    (e.Number = 'Number'),
    (e.Object = 'Object'),
    (e.String = 'String')
})(f || (f = {}))
var N = (function () {
  function e() {}
  return (
    (e.prototype.stringify = function () {
      return JSON.stringify(this.serialize())
    }),
    (e.prototype.serialize = function () {
      return b(this)
    }),
    (e.deserialize = function (e) {
      for (var a = [], t = 1; t < arguments.length; t++) a[t - 1] = arguments[t]
      return v.apply(void 0, r([e, this], a))
    }),
    (e = t([h()], e))
  )
})()
export {
  g as JsonProperty,
  h as Serializable,
  N as SerializableEntity,
  v as deserialize,
  b as serialize,
}
//# sourceMappingURL=index.esm.js.map
